#include "kmlistview.h"

#include <qcursor.h>

KMListView::KMListView(QWidget * parent, const char * name) : KListView(parent, name)
{
	setAcceptDrops(true);
	viewport()->setAcceptDrops(true);
	//setDropVisualizer(true);
	dndPerm = false;
	recentItem = NULL;
}

KMListView::~KMListView()
{
}

bool KMListView::acceptDrag(QDropEvent * event) const
{
	//return QTextDrag::canDecode(event);
}
/*
QDragObject * KMListView::dragObject()
{
}
*/
void KMListView::contentsMousePressEvent(QMouseEvent * e)
{
	switch (e->button())
	{
		case Qt::LeftButton:
			setSelected(itemAt(contentsToViewport(e->pos())), true);
			dndPerm = true;
			recentItem = currentItem();
		break;
		case Qt::RightButton:
			emit rightMouseButtonClicked(QCursor::pos());
		break;
		default:
		break;
	}
}

void KMListView::contentsMouseReleaseEvent(QMouseEvent * e)
{
	if (dndPerm)
		emit mouseButtonReleased(e->pos());

	dndPerm = false;
	viewport()->setCursor(Qt::ArrowCursor);
}

void KMListView::contentsMouseMoveEvent(QMouseEvent * e)
{
	if (!dndPerm)
		return;

	if (recentItem != itemAt(contentsToViewport(e->pos())))
		viewport()->setCursor(Qt::UpArrowCursor);

	int mPos = contentsToViewport(e->pos()).y();

	if ((mPos >= 0) && (mPos <= 20))
		scrollBy(0, -10);
	else
	{
		if ((mPos <= height()) && (mPos >= height() - 60))
			scrollBy(0, 10);
	}
}
/*
void KMListView::enterEvent(QEvent * e)
{
	QListViewItem * c = currentItem();

	if (!c)
		return;

	center(0, itemPos(c));
}
*/
void KMListView::keyPressEvent(QKeyEvent * e)
{
	emit keyPressed(e);
}
