#ifndef PLAYER_H
#define PLAYER_H

#include <qstring.h>
#include <qstringlist.h>
#include <qthread.h>

extern "C"
{
	#include <xine.h>
}

class CPlayer : public QThread
{
	public:
		CPlayer();
		~CPlayer();

		void setTrack(const QString & t);
		void setVolume(const int & vol);
		void setPos(const int & p);
		void setSoundSystem(const QString & system);

		int getLength() const;
		int getVolume() const;
		int getPos() const;
		QString getTrack() const;
		QStringList getAudioCDContents(const QString & device) const;
		const xine_t * getXineHandle() const;
		QString getXineVer() const;
		//int64_t getCurrentVpts() const;
				
		void run();

		void termThread();
		void wakeThread();

	private:
		QString xineVer;
		QString track;
		bool term;

		int volume;
		int length;
		int pos;

		xine_t            * xine;
		xine_stream_t     * stream;
		xine_audio_port_t * ao_port;
};

#endif
