/**

	randtree.h

	Random track selector engine header file

**/

#ifndef RANDTREE_H
#define RANDTREE_H

struct nod
{
	nod(const int & i)
	{
		index = i;
		left = 0;
		right = 0;
	}

	int index;

	mutable nod * left;
	mutable nod * right;
};

class CRandTree
{
	public:
		CRandTree();
		CRandTree(const CRandTree & t);
		~CRandTree();

		void addIndex(const int & i);
		bool searchForIndex(const int & i) const;
		void deleteIndex(const int & i);

		void remove();
		bool isEmpty() const;
		int getCount() const;

	private:
		void add(const nod * const n, const nod * const r);
		void del(const int & i, const nod * const r, const nod * const p);
		bool search(const int & i, const nod * const r) const;
		void remove(const nod * const r);

		nod * root;

		int count;
};

#endif
